sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=20
left=71
tile=1
caption="CD-Player-Datenbank-Viewer"
tileLayout=1
End CompInit
Dim group4 as group
group4 = MakeComponent("group",form1)
CompInit group4
proto="group4"
caption=""
look=1
tile=1
visible=1
End CompInit
Dim group5 as group
group5 = MakeComponent("group",group4)
CompInit group5
proto="group5"
caption="CD-Nr.: 01"
look=1
tile=1
sizeHControl=0
sizeVControl=3
width=162
visible=1
End CompInit
Dim group7 as group
group7 = MakeComponent("group",group5)
CompInit group7
proto="group7"
caption="Name:"
sizeVControl=3
tile=1
sizeHControl=3
visible=1
End CompInit
Dim name_entry as entry
name_entry = MakeComponent("entry",group7)
CompInit name_entry
proto="name_entry"
width=210
maxChars=32
text=""
filter=42
visible=1
End CompInit
name_entry.name="name_entry"
group7.name="group7"
Dim group8 as group
group8 = MakeComponent("group",group5)
CompInit group8
proto="group8"
caption="Interpret:"
sizeVControl=3
tile=1
sizeHControl=3
visible=1
End CompInit
Dim interp_entry as entry
interp_entry = MakeComponent("entry",group8)
CompInit interp_entry
proto="interp_entry"
width=210
maxChars=32
text=""
filter=42
visible=1
End CompInit
interp_entry.name="interp_entry"
group8.name="group8"
Dim group9 as group
group9 = MakeComponent("group",group5)
CompInit group9
proto="group9"
caption="UPC:"
sizeVControl=3
tile=1
sizeHControl=3
visible=1
End CompInit
Dim upc_entry as entry
upc_entry = MakeComponent("entry",group9)
CompInit upc_entry
proto="upc_entry"
width=210
maxChars=15
text=""
filter=32
visible=1
End CompInit
upc_entry.name="upc_entry"
group9.name="group9"
group5.name="group5"
Dim group3 as group
group3 = MakeComponent("group",group4)
CompInit group3
proto="group3"
caption="Titel:"
look=1
tile=1
tileLayout=1
tileVAlign=2
sizeHControl=3
sizeVControl=3
tileSpacing=10
visible=1
End CompInit
Dim group1 as group
group1 = MakeComponent("group",group3)
CompInit group1
proto="group1"
caption="group1"
look=2
tile=1
visible=1
End CompInit
Dim t01_entry as entry
t01_entry = MakeComponent("entry",group1)
CompInit t01_entry
proto="t01_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t01_entry.name="t01_entry"
Dim t02_entry as entry
t02_entry = MakeComponent("entry",group1)
CompInit t02_entry
proto="t02_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t02_entry.name="t02_entry"
Dim t03_entry as entry
t03_entry = MakeComponent("entry",group1)
CompInit t03_entry
proto="t03_entry"
width=250
maxChars=32
filter=42
text=""
visible=1
End CompInit
t03_entry.name="t03_entry"
Dim t04_entry as entry
t04_entry = MakeComponent("entry",group1)
CompInit t04_entry
proto="t04_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t04_entry.name="t04_entry"
Dim t05_entry as entry
t05_entry = MakeComponent("entry",group1)
CompInit t05_entry
proto="t05_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t05_entry.name="t05_entry"
Dim t06_entry as entry
t06_entry = MakeComponent("entry",group1)
CompInit t06_entry
proto="t06_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t06_entry.name="t06_entry"
Dim t07_entry as entry
t07_entry = MakeComponent("entry",group1)
CompInit t07_entry
proto="t07_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t07_entry.name="t07_entry"
Dim t08_entry as entry
t08_entry = MakeComponent("entry",group1)
CompInit t08_entry
proto="t08_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t08_entry.name="t08_entry"
Dim t09_entry as entry
t09_entry = MakeComponent("entry",group1)
CompInit t09_entry
proto="t09_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t09_entry.name="t09_entry"
Dim t10_entry as entry
t10_entry = MakeComponent("entry",group1)
CompInit t10_entry
proto="t10_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t10_entry.name="t10_entry"
Dim t11_entry as entry
t11_entry = MakeComponent("entry",group1)
CompInit t11_entry
proto="t11_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t11_entry.name="t11_entry"
Dim t12_entry as entry
t12_entry = MakeComponent("entry",group1)
CompInit t12_entry
proto="t12_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t12_entry.name="t12_entry"
Dim t13_entry as entry
t13_entry = MakeComponent("entry",group1)
CompInit t13_entry
proto="t13_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t13_entry.name="t13_entry"
group1.name="group1"
Dim group2 as group
group2 = MakeComponent("group",group3)
CompInit group2
proto="group2"
caption="group2"
look=2
tile=1
visible=1
End CompInit
Dim t14_entry as entry
t14_entry = MakeComponent("entry",group2)
CompInit t14_entry
proto="t14_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t14_entry.name="t14_entry"
Dim t15_entry as entry
t15_entry = MakeComponent("entry",group2)
CompInit t15_entry
proto="t15_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t15_entry.name="t15_entry"
Dim t16_entry as entry
t16_entry = MakeComponent("entry",group2)
CompInit t16_entry
proto="t16_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t16_entry.name="t16_entry"
Dim t17_entry as entry
t17_entry = MakeComponent("entry",group2)
CompInit t17_entry
proto="t17_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t17_entry.name="t17_entry"
Dim t18_entry as entry
t18_entry = MakeComponent("entry",group2)
CompInit t18_entry
proto="t18_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t18_entry.name="t18_entry"
Dim t19_entry as entry
t19_entry = MakeComponent("entry",group2)
CompInit t19_entry
proto="t19_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t19_entry.name="t19_entry"
Dim t20_entry as entry
t20_entry = MakeComponent("entry",group2)
CompInit t20_entry
proto="t20_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t20_entry.name="t20_entry"
Dim t21_entry as entry
t21_entry = MakeComponent("entry",group2)
CompInit t21_entry
proto="t21_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t21_entry.name="t21_entry"
Dim t22_entry as entry
t22_entry = MakeComponent("entry",group2)
CompInit t22_entry
proto="t22_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t22_entry.name="t22_entry"
Dim t23_entry as entry
t23_entry = MakeComponent("entry",group2)
CompInit t23_entry
proto="t23_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t23_entry.name="t23_entry"
Dim t24_entry as entry
t24_entry = MakeComponent("entry",group2)
CompInit t24_entry
proto="t24_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t24_entry.name="t24_entry"
Dim t25_entry as entry
t25_entry = MakeComponent("entry",group2)
CompInit t25_entry
proto="t25_entry"
width=250
maxChars=32
text=""
filter=42
visible=1
End CompInit
t25_entry.name="t25_entry"
group2.name="group2"
group3.name="group3"
Dim group10 as group
group10 = MakeComponent("group",group4)
CompInit group10
proto="group10"
caption=""
look=1
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
tileSpacing=5
visible=1
End CompInit
Dim back_button as button
back_button = MakeComponent("button",group10)
CompInit back_button
proto="back_button"
caption="|<"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
back_button.name="back_button"
Dim prev_button as button
prev_button = MakeComponent("button",group10)
CompInit prev_button
proto="prev_button"
caption="<"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
prev_button.name="prev_button"
Dim next_button as button
next_button = MakeComponent("button",group10)
CompInit next_button
proto="next_button"
caption=">"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
next_button.name="next_button"
group10.name="group10"
group4.name="group4"
Dim datei_popup as popup
datei_popup = MakeComponent("popup",form1)
CompInit datei_popup
proto="datei_popup"
caption="Datei"
visible=1
End CompInit
Dim export_button as button
export_button = MakeComponent("button",datei_popup)
CompInit export_button
proto="export_button"
caption="Export"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
export_button.name="export_button"
Dim about_button as button
about_button = MakeComponent("button",datei_popup)
CompInit about_button
proto="about_button"
caption="ber..."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
about_button.name="about_button"
datei_popup.name="datei_popup"
Dim popup2 as popup
popup2 = MakeComponent("popup",form1)
CompInit popup2
proto="popup2"
caption="Sprache"
left=0
top=0
visible=1
End CompInit
Dim ger_choice as choice
ger_choice = MakeComponent("choice",popup2)
CompInit ger_choice
proto="ger_choice"
caption="Deutsch"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
ger_choice.name="ger_choice"
Dim eng_choice as choice
eng_choice = MakeComponent("choice",popup2)
CompInit eng_choice
proto="eng_choice"
caption="English"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
eng_choice.name="eng_choice"
popup2.name="popup2"
form1.width=466
form1.height=395
form1.name="form1"
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
' v01 - Layout (14.07.)
' v02 - Sprachumschaltung (15.07.)
' v03 - Anzahl Datensaetze ermitteln (16.07.)
' v04 - Datensaetze in Array auslesen und anzeigen (17.07.)
' v05 - Anzeige funktioniert jetzt (19.07.)
'     - Rueckbutton eingebaut (19.07.)
' v06 - Export in CSV (20.07.)
' v07 - nicht genutzte Tracks bereinigen (20.07.)
' v08 - File-Check (21.07.)
' v08a- SetLanguage und cdrec[] ueberarbeitet
'     - CsvExport() mit Parameteren fuer allg. Einsatz versehen

' CD-Player-Datendatei
dim cdpfile as component
cdpfile = MakeComponent("file","top")
cdpfile.name = "bbcdplay.dat"

LanguageCheck(1)

dim applng      as string ' verwendete Ui-Sprache lt. optosoft.lng
dim about_title as string ' String fuer About-Box
dim export_msg  as string ' Export-Hinweisbox
dim filechk_msg as string ' Filefehlerhinweis
dim filechk_tit as string ' Titel fuer MsgBox
dim cdpsize as integer
dim anzahlrec as integer  ' Anzahl Datensaetze in Datenbankfile

cdpsize = cdpfile.size
anzahlrec = ((cdpsize - 32) / 989) ' Anzahl Datensaetze = (Dateigroesse - Header) / Datensatzgroesse
dim cdrec[anzahlrec,29] as string
' 1 - UPC
' 2 - CD-Name
' 3 - Interpret
' 4-28 - Tracks 1-25

dim position as integer

' FileCheck
if cdpfile.size < 1000
	MessageBox(filechk_tit, filechk_msg)
	form1.enabled = 0
else
	CDPFauslesen()
	next_button_pressed(next_button)
end if

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub LanguageCheck(flag as integer)

' flag = 1 - Aufruf bei Programmstart
' flag = 2 - Aufruf bei Choice-Aenderung

' Sprachdatei definieren
dim lngfile as component
lngfile = MakeComponent("file","top")
lngfile.name = "optosoft.lng"

' Auswertung

if flag = 1
	dim lngchk as string
	lngfile.go(0)
	lngchk = left(lngfile.read(1),1)

	if lngchk = "E"
		applng = "english"
		eng_choice.status = 1
	else
		applng = "deutsch"
		ger_choice.status = 1
	end if
else
	lngfile.open()
	lngfile.go(0)
	if eng_choice.status = 1
		applng = "english"
		lngfile.write("E",1)
	else
		applng = "deutsch"
		lngfile.write("D",1)
	end if
	lngfile.close()
	if ger_choice.status = 0 and eng_choice.status = 0
		ger_choice.status = 1
	end if
end if

SetLanguage()

end sub

sub SetLanguage()

if applng = "english"
	datei_popup.caption = "File"
	popup2.caption = "Language"
	form1.caption = "CD-Player-Database-Viewer"
	group3.caption = "Tracks:"
	about_button.caption = "About..."
	about_title = "About CDPDV"
	export_msg = "Export ended. File: "
	filechk_msg = "Wrong database 'bboxcdplay.dat'."
	filechk_tit = "Error"
else
	datei_popup.caption = "Datei"
	popup2.caption = "Sprache"
	form1.caption = "CD-Player-Datenbank-Viewer"
	group3.caption = "Titel:"
	about_button.caption = "ber..."
	about_title = "ber CDPDV"
	export_msg = "Export beendet. Datei: "
	filechk_msg = "Datendatei 'bboxcdplay.dat' fehlerhaft."
	filechk_tit = "Fehler"
end if

end sub

sub ger_choice_changed(self as choice)
	LanguageCheck(2)
end sub

sub eng_choice_changed(self as choice)
	LanguageCheck(2)
end sub

sub CDPFauslesen()

' Routine zum auslesen des Datenfiles und Uebergabe an Variable

busy1.Enter()
cdpfile.open()

dim c1 as integer
dim c2 as integer

for c1 = 0 to anzahlrec-1
	c2 = (c1 * 989) + 33
	cdpfile.go(c2)
	cdrec[c1,1] = cdpfile.read(15)
	cdpfile.go(c2+15)
	cdrec[c1,2] = cdpfile.read(30)
	cdpfile.go(c2+125)
	cdrec[c1,3] = cdpfile.read(32)
	cdpfile.go(c2+157)
	cdrec[c1,4] = cdpfile.read(32)
	cdpfile.go(c2+189)
	cdrec[c1,5] = cdpfile.read(32)
	cdpfile.go(c2+221)
	cdrec[c1,6] = cdpfile.read(32)
	cdpfile.go(c2+253)
	cdrec[c1,7] = cdpfile.read(32)
	cdpfile.go(c2+285)
	cdrec[c1,8] = cdpfile.read(32)
	cdpfile.go(c2+317)
	cdrec[c1,9] = cdpfile.read(32)
	cdpfile.go(c2+349)
	cdrec[c1,10] = cdpfile.read(32)
	cdpfile.go(c2+381)
	cdrec[c1,11] = cdpfile.read(32)
	cdpfile.go(c2+413)
	cdrec[c1,12] = cdpfile.read(32)
	cdpfile.go(c2+445)
	cdrec[c1,13] = cdpfile.read(32)
	cdpfile.go(c2+477)
	cdrec[c1,14] = cdpfile.read(32)
	cdpfile.go(c2+509)
	cdrec[c1,15] = cdpfile.read(32)
	cdpfile.go(c2+541)
	cdrec[c1,16] = cdpfile.read(32)
	cdpfile.go(c2+573)
	cdrec[c1,17] = cdpfile.read(32)
	cdpfile.go(c2+605)
	cdrec[c1,18] = cdpfile.read(32)
	cdpfile.go(c2+637)
	cdrec[c1,19] = cdpfile.read(32)
	cdpfile.go(c2+669)
	cdrec[c1,20] = cdpfile.read(32)
	cdpfile.go(c2+701)
	cdrec[c1,21] = cdpfile.read(32)
	cdpfile.go(c2+733)
	cdrec[c1,22] = cdpfile.read(32)
	cdpfile.go(c2+765)
	cdrec[c1,23] = cdpfile.read(32)
	cdpfile.go(c2+797)
	cdrec[c1,24] = cdpfile.read(32)
	cdpfile.go(c2+829)
	cdrec[c1,25] = cdpfile.read(32)
	cdpfile.go(c2+861)
	cdrec[c1,26] = cdpfile.read(32)
	cdpfile.go(c2+893)
	cdrec[c1,27] = cdpfile.read(32)
	cdpfile.go(c2+925)
	cdrec[c1,28] = cdpfile.read(32)
next

cdpfile.close()
busy1.Leave()

TrackClear()

end sub

sub next_button_pressed(self as button)

if position < anzahlrec
	position = position + 1
else
	position = 1
end if

DatenAusgabe(position)

end sub

sub DatenAusgabe(position as integer)

group5.caption = "CD: "+str(position)+"/"+str(anzahlrec)

upc_entry.text    = cdrec[position-1, 1]
name_entry.text   = cdrec[position-1, 2]
interp_entry.text = cdrec[position-1, 3]

t01_entry.text    = cdrec[position-1, 4]
t02_entry.text    = cdrec[position-1, 5]
t03_entry.text    = cdrec[position-1, 6]
t04_entry.text    = cdrec[position-1, 7]
t05_entry.text    = cdrec[position-1, 8]
t06_entry.text    = cdrec[position-1, 9]
t07_entry.text    = cdrec[position-1,10]
t08_entry.text    = cdrec[position-1,11]
t09_entry.text    = cdrec[position-1,12]
t10_entry.text    = cdrec[position-1,13]
t11_entry.text    = cdrec[position-1,14]
t12_entry.text    = cdrec[position-1,15]
t13_entry.text    = cdrec[position-1,16]
t14_entry.text    = cdrec[position-1,17]
t15_entry.text    = cdrec[position-1,18]
t16_entry.text    = cdrec[position-1,19]
t17_entry.text    = cdrec[position-1,20]
t18_entry.text    = cdrec[position-1,21]
t19_entry.text    = cdrec[position-1,22]
t20_entry.text    = cdrec[position-1,23]
t21_entry.text    = cdrec[position-1,24]
t22_entry.text    = cdrec[position-1,25]
t23_entry.text    = cdrec[position-1,26]
t24_entry.text    = cdrec[position-1,27]
t25_entry.text    = cdrec[position-1,28]

end sub

sub back_button_pressed(self as button)

position = 1
DatenAusgabe(position)

end sub

sub prev_button_pressed(self as button)

position = position - 1

if position < 1
	position = anzahlrec
end if

DatenAusgabe(position)

end sub

sub MessageBox(msgb_title as string, msgb_message as string)

	dim msgb_dialog as component
	msgb_dialog = MakeComponent("dialog", "app")
	msgb_dialog.proto ="msgb_dialog"
	msgb_dialog.caption = msgb_title
	msgb_dialog.sizeHControl=3
	msgb_dialog.sizeVControl=3

	dim msgb_group as component
	msgb_group = MakeComponent("group", msgb_dialog)
	msgb_group.proto = "msgb_group"
	msgb_group.look = 0
	msgb_group.sizeHControl=3
	msgb_group.sizeVControl=3
	msgb_group.tile = 1
	msgb_group.tileSpacing = 5
	msgb_group.left = 0
	msgb_group.top = 0
	msgb_group.tileHAlign = 0

   	dim msgb_text as component
	msgb_text = MakeComponent("label", msgb_group)
	msgb_text.proto = "msgb_text"
	msgb_text.caption = msgb_message

	dim msgb_btn as component
	msgb_btn = MakeComponent("button", msgb_group)
	msgb_btn.proto = "msgb_btn"
	msgb_btn.caption = "OK"
	msgb_btn.visible = 1
	msgb_btn.default = 1
	msgb_btn.closeDialog = 1

	msgb_group.visible = 1
	msgb_text.visible = 1
	msgb_dialog.visible = 1

end sub

sub about_button_pressed(self as button)
	MessageBox(about_title,"(c) by Dirk Haase, OptoSoft 1998")
end sub

sub TrackClear()
' zum entfernen der Track-Eintraege von nicht benutzen Tracks

dim cx as integer
dim cy as integer

for cy = 0 to anzahlrec-1
	for cx = 1 to 28
		if left(cdrec[cy, cx],6) = "Track "
			cdrec[cy,cx] = "---"
		end if
	next cx
next cy

end sub

sub CsvExport(arrayname[] as string, filename as string)

dim ysize as integer
dim xsize as integer

busy1.Enter()

xsize = GetArraySize(arrayname,0) - 1
ysize = GetArraySize(arrayname,1) - 1

dim testfile as component
testfile = MakeComponent("file","top")
testfile.name = filename
testfile.create()
testfile.size = 0
testfile.open()

dim dummystring as string
dim cx as integer
dim cy as integer

for cx = 0 to xsize
	for cy = 1 to ysize
		if cy < ysize
			dummystring = dummystring + chr(34) + arrayname[cx,cy] + chr(34) + ","
		else
			dummystring = dummystring + chr(34) + arrayname[cx,cy] + chr(34)
		end if
	next cy
'		dummystring = dummystring + "\r"
		dummystring = dummystring + "\r" + chr(34)
next cx

testfile.write(dummystring, len(dummystring))
testfile.close()

busy1.Leave()

MessageBox("Export",export_msg+filename+".")

end sub

sub export_button_pressed(self as button)
	CsvExport(cdrec,"bbcdplay.csv")
end sub

